<?php
#-------------------------------------------------------------------------------
#	$Id$
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
#	Config
#-------------------------------------------------------------------------------

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@									@@@@@@@@
#@@@									@@@@@@@@
#@@@	HIER DAS VERZEICHNIS ANGEBEN, AN DEM DIE *.hgt DATEIEN LIEGEN	@@@@@@@@
#@@@									@@@@@@@@
#@@@									@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


$HGT_DIR = preg_replace( "!/php/.*!", "", $_SERVER{"SCRIPT_FILENAME"}) . "/hgt";


#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#-------------------------------------------------------------------------------
#	defaults
#-------------------------------------------------------------------------------

$steps = 50;

#-------------------------------------------------------------------------------
#	constants
#-------------------------------------------------------------------------------

$RHO	      = 180.0 / 3.1415926535;
$EARTH_RADIUS = 6378137.0;

#-------------------------------------------------------------------------------
#	HTTP header
#-------------------------------------------------------------------------------

header( "HTTP/1.1 200 Ok");
header( "Content-Type: text/plain; charset=UTF-8" );

#-------------------------------------------------------------------------------
#	error handler
#-------------------------------------------------------------------------------

function Fail( $message ){

	echo "{\"error\":", json_encode( $message ), "}\n";
	exit( 1 );
}

#-------------------------------------------------------------------------------
#	process query
#-------------------------------------------------------------------------------

$Lons = [];
$Lats = [];

$query = $_SERVER[ "QUERY_STRING" ];

foreach( explode( "&", $query ) as $tagval ){

	#-----------------------------------------------------------------------
	#	setzt die räumliche Aufloesung
	#-----------------------------------------------------------------------

	if( preg_match( "!^steps=([1-9]\\d*)$!", $tagval, $match ) ){

		$steps = intval( match[ 1 ]);
		continue;
	}

	#-----------------------------------------------------------------------
	#	Koordinate
	#-----------------------------------------------------------------------

	if( preg_match( "!^(-?\\d+\\.?\\d*),(-?\\d+\\.?\\d*)$!", $tagval, $match ) ){

		$Lons[] = floatval( $match[ 1 ] );
		$Lats[] = floatval( $match[ 2 ] );
		continue;
	}

	#-----------------------------------------------------------------------
	#	undef
	#-----------------------------------------------------------------------

	Fail( "Invalid query: {$tagval}" );
}

if( !count( $Lons ) ){ Fail( "No lonlats" ); }

#-------------------------------------------------------------------------------
#	Saldos
#-------------------------------------------------------------------------------

$flatDistance = 0;
$hypoDistance = 0;
$ascend       = 0;
$descend      = 0;
$nUndefineds  = 0;

$firstEle;
$lastEle;
$minEle;
$maxEle;

#-------------------------------------------------------------------------------
#	saldiere Entfernungen und Hoehen
#-------------------------------------------------------------------------------

function processEle( $ele, $dist ){

	global $flatDistance;
	global $hypoDistance;
	global $ascend;
	global $descend;
	global $nUndefineds;
	global $firstEle;
	global $lastEle;
	global $minEle;
	global $maxEle;

	$delta = 0;

	if( isset( $ele ) ){

		if( !isset( $lastEle ) ){

			$minEle = $maxEle = $firstEle = $lastEle = $ele;
		}

		$minEle = min( $ele, $minEle );
		$maxEle = max( $ele, $maxEle );

		$delta  = $ele - $lastEle;

		if( $delta > 0 ){ $ascend  += $delta; }
		if( $delta < 0 ){ $descend += $delta; }

		$lastEle = $ele;
	} else {
		++$nUndefineds;
	}

	$flatDistance += $dist;
	$hypoDistance += sqrt( $dist*$dist + $delta*$delta );
}

#-------------------------------------------------------------------------------
#	Bearbeite uebergebene Koordinaten
#-------------------------------------------------------------------------------

$baseLon = $Lons[ 0 ];
$baseLat = $Lats[ 0 ];

processEle( getEle( $baseLon, $baseLat ), 0);

for( $i=1; $i<count( $Lons ); ++$i ){

	$nextLon = $Lons[ $i ];
	$nextLat = $Lats[ $i ];

	#-----------------------------------------------------------------------
	#	Positionen im Bogenmass
	#-----------------------------------------------------------------------

	$phi1    = $baseLat / $RHO;
	$phi2    = $nextLat / $RHO;

	$lambda1 = $baseLon / $RHO;
	$lambda2 = $nextLon / $RHO;

	#-----------------------------------------------------------------------
	#	Distance
	#-----------------------------------------------------------------------

	$radDistance = acos(sin($phi1) * sin($phi2) +
			cos($phi1) * cos($phi2) * cos( $lambda1-$lambda2 ));

	$stepFlatDistance = $EARTH_RADIUS * $radDistance / $steps;

	#-----------------------------------------------------------------------
	#	lon/lat Inkremente zwischen zwei Schritten
	#-----------------------------------------------------------------------

	$deltaLon = ( $nextLon - $baseLon ) / $steps;
	$deltaLat = ( $nextLat - $baseLat ) / $steps;

	for( $step = 1; $step <= $steps; ++$step) {

		$stepLon = $baseLon + $step * $deltaLon;
		$stepLat = $baseLat + $step * $deltaLat;

		processEle( getEle( $stepLon, $stepLat ), $stepFlatDistance );
	}

	$baseLon = $nextLon;
	$baseLat = $nextLat;
} 

#-------------------------------------------------------------------------------
#	Json
#-------------------------------------------------------------------------------

echo "{\n";
echo '"query": ', json_encode($query), "\n";

echo ',"distance": ',     intval( $hypoDistance ), "\n";
echo ',"flatDistance": ', intval( $flatDistance ), "\n";

if( isset( $lastEle ) ){

	echo ',"ascend": '  , $ascend,   "\n";
	echo ',"descend": ' , $descend,  "\n";
	echo ',"firstEle": ', $firstEle, "\n";
	echo ',"lastEle": ' , $lastEle,  "\n";
	echo ',"minEle": '  , $minEle,   "\n";
	echo ',"maxEle": '  , $maxEle,   "\n";
}

if( $nUndefineds ){ echo ',"nUndefineds": ', $nUndefineds, "\n"; }

echo "}\n";

exit ( 0 );

#-------------------------------------------------------------------------------
#	Bestimme Hoehe zu Koordinaten
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
#	cache
#-------------------------------------------------------------------------------

$cachedLon = 1e10;
$cachedLat = 1e10;
$cachedEle = 0;

$cachedFilename = '';
$cachedFiledata;

function getEle( $lon, $lat ){

	global $cachedLon;
	global $cachedLat;
	global $cachedEle;

	#-----------------------------------------------------------------------
	#	Nutze Cache
	#-----------------------------------------------------------------------

	if( $lon == $cachedLon && $lat == $cachedLat ){ return $cachedEle; }

	$cachedLon = $lon;
	$cachedLat = $lat;

	unset( $cachedEle );

	#-----------------------------------------------------------------------
	#	Bestimme Kachel
	#-----------------------------------------------------------------------

	$iLonDeg = floor( $lon );
	$iLatDeg = ceil ( $lat ) - 1;

	#-----------------------------------------------------------------------
	#	ele+40-006.hgt
	#-----------------------------------------------------------------------

	global $HGT_DIR;

	$filename = sprintf( '%s/%s%02d%s%03d.hgt',
		$HGT_DIR,
		( $iLatDeg >= 0 ? "N" : "S" ), abs( $iLatDeg ),
		( $iLonDeg >= 0 ? "E" : "W" ), abs( $iLonDeg ) );


	#-----------------------------------------------------------------------
	#	Nutze file cache
	#-----------------------------------------------------------------------

	global $cachedFilename;
	global $cachedFiledata;

	if( $filename != $cachedFilename ){

		$cachedFilename = $filename;
		$cachedFiledata = @file_get_contents( $filename );
	}

	#-----------------------------------------------------------------------
	#	Bestimme Rastergröße
	#-----------------------------------------------------------------------
	#	Die Daten beginn auf Rand und enden auf Rand, deshalb sind es
	#	1 mehr als Datenpunkte erwartet. Short signed braucht 2 Byte
	#-----------------------------------------------------------------------

	$datasize   = strlen( $cachedFiledata );
	$rasterSize = round( sqrt( $datasize/2 ) - 1 );

	if( $rasterSize <= 0 ||
		($rasterSize+1) * ($rasterSize+1) * 2 != $datasize ){

		Fail( "invalid filesize '$datasize' of '$filename'" );
	}

	#-----------------------------------------------------------------------
	#	Position in Kachel (0° .. 1°) → ( 0 .. rasterSize )
	#-----------------------------------------------------------------------

	$x = (     ( $lon - $iLonDeg )) * $rasterSize + 0.5;
	$y = ( 1 - ( $lat - $iLatDeg )) * $rasterSize + 0.5;

	#-----------------------------------------------------------------------
	#	Aufteilung in Ganzzahl und Fraction
	#-----------------------------------------------------------------------

	$intX = floor( $x );
	$intY = floor( $y );

	$fracX = $x - $intX;
	$fracY = $y - $intY;

	#-----------------------------------------------------------------------
	#	lese "obere" Zeile
	#-----------------------------------------------------------------------

	$offset  = 2 * ( ($intY+0) * ($rasterSize+1) + $intX );

	$lr = unpack( "n1l/n1r", $cachedFiledata, $offset );
	$t = $lr['l'] * ( 1 - $fracX ) + $lr['r'] * $fracX;

	$offset  = 2 * ( ($intY+1) * ($rasterSize+1) + $intX );

	$lr = unpack( "n1l/n1r", $cachedFiledata, $offset );
	$b = $lr['l'] * ( 1 - $fracX ) + $lr['r'] * $fracX;

	$cachedEle = round( $t * ( 1 - $fracY ) + $b * $fracY );

	if( $cachedEle >= 12000 ){ unset( $cachedEle ); }

	return $cachedEle;
}

#-------------------------------------------------------------------------------
#	$Id$
#-------------------------------------------------------------------------------
?>
